 state                          |

|===============================|
|                               |
|   TEST POSTFIX LANGUAGE       |
|                               |
|   Charles E V Pegge           |
|                               |
|   5-17 Sept 2007              |
|                               |
================================|
|                               |
  ( ""? "TESTS"  ? "" ? )       |
                                |
|-------------------------------|
 ("" ? "testing 'hello'"? ""?)  |
                                |
|-------------------------------|
 (                              | record stack position
|-------------------------------|
                                |
 'hello world' ?                |
 'hello' ' world'  + ?          |
 ?                              |
 upper ?                        |
                                |
                                |
 'hello ': greet                |
 'world' : who                  |
                                |
 greet who + ?                  |
                                |
 'sky' to who                   |
                                |
 greet who + ?                  |
 (greet who + ?)                |
                                |
                                |
 )                              |
|-------------------------------|
 (""? "testing 'def'"? ""?)     |
|-------------------------------|
 (                              |
  def abc                       |
   3 args : a : b : c           |
   (a? b? c?)                   |
   + + ?                        |
   1 rets                       |
  end                           |
  1 2 3 abc ?                   |
 ""?                            |
 )                              |
|-------------------------------|
 (                              |
 "testing 'if'"?                |
  1 1 cmp if EQ 'hello' ? endif |
  1 0 cmp if EQ 'world' ? endif |
 ""?                            |
 )                              |
|-------------------------------|
 (                              |
 "testing 'exit'"?              |
  ( "hello"? exit 'world' )     |
 ""?                            |
 )                              |
|-------------------------------|
 (                              |
 "testing scopes"?              |
 "ok"                           |
 ( 1 2 3 + + ?) ?               |
 ""?                            |
 )                              |
|-------------------------------|
 (                              |
 "testing assign 'to'"?         |
 "" ?                           |
  0:a                           |
  0:b                           |
  'hello':c                     |
 (33 1+ to b) a b 1+  ?         |
 ""?                            |
 )                              |
|-------------------------------|
                                |
 (                              |
 "testing arrays"?              |
 "" ?                           |
 10 array 5:a                   |
 ('hello' 2 idx to a ?)         |
 3 1- idx a ? a ?               |
 ""?                            |
 )                              |
                                |
                                |
|-------------------------------|
(""?"testing 'pass by ref'"? ""?)
|-------------------------------|
 (                              |
 def store                      |
  2  args : a : b               |
  a to b                        |
 end                            |
                                |
                                |
  1:aa                          |
  2:bb                          |
  3:cc                          |
  ('before:' ? aa? bb?)         |
  ( ref aa ref bb  store)       |
  (                             |
   'after:' ?                   |
   aa ?                         |
   bb ?                         |
   cc ?                         |
   "" ?                         |
  )                             |
                                |
 )                              |
|-------------------------------|
 (""? "testing objects"? "" ?)  |
|-------------------------------|
 (                              |
                                |
def blue                        |
 "blue"?                        |
end                             |
                                |
|-------------------------------|
| defining an object in markup  |
|-------------------------------|
  "
  <aa>hello</>
 <bb>world</>
  <vv>#42</>
  <who>!
   def indigo
    'indigo'?
   end
   blue 'sky'?
   indigo
   this.vv?
   this.aa?
  </>
  "
|-------------------------------|
                                |
  : s                           |
  s.aa?                         |
  s.bb?                         |
  s.who                         |
  s.vv 1 + ?                    |
                                |
                                |
                                |
  )                             |
|-------------------------------|
(""? "Test Loops"? "" ?)        |
|-------------------------------|
(                               |
5:i                             | dim i as long: i=5
(                               | do
 i? dec i                       |  print i: decr i
 if LE                          |  if i<=0 then
  exit                          |   exit do
 endif                          | end if
 repeat                         | 
)                               | loop
(                               | do
 inc i ?                        |  incr i: print i
 i 5 -                          |  if i<5 _
 if LT                          |  then
  repeat                        |   continue do
 endif                          |  end if
)                               |  exit do
)                               | loop
|-------------------------------|
  (""? "Test Internals"? "" ?)  |
|-------------------------------|
(                               |
 |state                         |
 @1 ?                           |
 state                          |
 @1 ?                           | var stack pointer
 @2 ?                           | func stack pointer
 @3 ?                           | bracket stack pointer
 @4 ?                           | block stack pointer
 @5 ?                           | instrunction pointer
 @6 ?                           | length of instruction string
 @7 ?                           | instruction string
)                               |
|-------------------------------|
|-------------------------------|
  (""? "Nested Defs"? "" ?)     |
|-------------------------------|
(                               |
 def abc                        |
  def xyz                       |
   "xyz" ?                      |
  end                           |
  "abc"?                        |
  xyz                           |
 end                            |
 abc                            |
                                |
)                               |
|-------------------------------|
                                |
|-------------------------------|
(                               |
 ""?                            |
 "len"?                         |
 "1234":s s?  ref s len? s len? |
 42 len? ""?                    |
)                               |
|-------------------------------|
                                |
(                               |
 ""? "to and mov"?              |
 32:a       a?                  |
 ref a:b    b?                  |
 44 to b    a?                  |
 22 mov b   a?                  |
            b?                  |
)                               |
                                |
|-------------------------------|
| INTERNAL FUNCTIONS            |
|-------------------------------|
                                |
(                               |
 ""? "mid and patch"?           |
 "12345"? 3 2 mid?              |
 "12345"? "cd" 3 patch?         |
 "abcdef":s                     |
 ref s "<" 6 patch s?           |
                                |
)                               |
                                |
|-------------------------------|
                                |
(                               |
 ""? "str and val"?             |
 "12345"? val 1+ ?              |
 12345? str "A" +?              |
                                |
)                               |
                                |
|-------------------------------|
                                |
(                               |
 ""? "pos and insert"?          |
 "abcdef" ?    :s               |
 s "c" 2 pos ? :j               |
 s "CCC" 1   4   insert ?       |
 s "CCC" j j 3 + insert ?       |
                                |
                                |
                                |
)                               |
                                |
|-------------------------------|
| with types                    |
|-------------------------------|
(                               |
 ""? "find and replace"?        | print: print "find and replace"
 string "ab cd e fg" : s        | dim s as string :  s="ab cd e fg"
 ?                              | print s
 string " "  : f                | dim f as string :  f=" "
 long   len  : lf               | dim lf as long  :  lf=len(f)
 string ", " : r                | dim r as string :  r=", "
 long len    : lr               | dim lr as long  :  lr=len(r)
 long 1      : i                | dim i as long   :  i=1
 (                              | do
  ref s f i pos to i            |  i=instr(i,s,f)
  if null pop exit endif        |  if i=0 then exit do
  pop ref s r i i lf + insert   |  s=insert (s,r,i,i+lf)
  pop i lr + to i               |  i=i+lr
  pop repeat                    |
 )                              | loop
                                |
 s?                             | print s
)                               | ' end
                                |
|-------------------------------|
(                               |
 ""? "find and replace mk2 "?   | print: print "find and replace"
 string "ab cd e fg" : s        | dim s as string :  s="ab cd e fg"
 ?                              | print s
 string  " "  : f               | dim f as string :  f=" "
 long    len  : lf              | dim lf as long  :  lf=len(f)
 string  ", " : r               | dim r as string :  r=", "
 long    len  : lr              | dim lr as long  :  lr=len(r)
 long    1    : i               | dim i as long   :  i=1
                                |
 (                              | do
  ref s f i pos to i            |  i=instr(i,s,f)
  if null exit endif            |  if i=0 then exit do
  ref s r i i lf + insert       |  s=insert (s,r,i,i+lf)
  i lr + to i                   |  i=i+lr
  repeat                        |
 )                              | loop
                                |
 s?                             | print s
)                               |
                                |
|-------------------------------|
def find_and_replace            | sub find_and_replace _
 3 args                         | ( _
 :s                             | s as string, _
 :f                             | f as string, _
 :r                             | r as string )
 f long  len    : lf            | dim lf as long  :  lf=len(f)
 r long  len  : lr              | dim lr as long  :  lr=len(r)
 long    1      : i             | dim i as long   :  i=1
 (                              | do
 ref s f i pos to i             |  i=instr(i,s,f)
 if null exit endif             |  if i=0 then exit do
  ref s r i i lf + insert       |  s=insert (s,r,i,i+lf)
  i lr + to i                   |  i=i+lr
  repeat                        |
 )                              | loop
 end                            | end sub
                                |
 ""? "find and replace mk3 "?   | print: print "find and replace"
 string "ab cd e fg" : s        | dim s as string :  s="ab cd e fg"
 ?                              | print s
 ref s " " ", " find_and_replace | find_and_replace(s,",",", ")
 s?                             | print s
                                |
|-------------------------------|
(                               |
 ""? "go #"?                    |
 (                              | do
  go here                       | goto here1
  (                             | do
   #here                        | here:
   "not here"?                  | print "not here"
  )                             | exit do: loop
  #here                         | here1:
  "here1"?                      | print "here1"
 )                              | exit do: loop
 #here                          | here2:
 "here2"?                       | print "here2"
)                               |
                                |
|-------------------------------|

$
Test iquote output
Hello World!
`2`
`1 3+`
okay
$

|-------------------------------|
                                |
 (                              |
 ""? "File io tests:"?          |
 "t.txt" openout : fo           |
 fo "hello!" out                |
 fo close                       |
                                |
 "t.txt" file : ff              |
 ff lof ?                       |
 ff 1 seek                      |
 ff 10 get ?                    |
 ff 2 seek                      |
 ff "u" put                     |
 ff close                       |
                                |
 "t.txt" openin : fi            |
 fi in ?                        |
 fi close                       |
 )                              |
                                |
|-------------------------------|
(                               |
| cls                           |
| 14 251 color                  |
| 5 10 1 locate  "here"?        |
                                |
 "" ? "Console tests" ?         |
"Enter something: "             |
 getline ltrim upper ?          |
 5 many ?                       |
 1 asc str "Ascii: " swap + ?   |
 ""? "Numeric:"?                |
 degrees                        |
 1 atn  ?                       |
 60 sin ?                       |
 60 cos ?                       |
 30 tan ?                       |
 radians                        |
 1 atn ?                        |
 "" ?                           |
|-------------------------------|
                                |
 1 2 3 range "1 2 3 "??         |
 if false then                  |
  "not " ??                     |
 endif                          |
 "in range" ?                   |
                                |
 "1 2 neg 3 " ?? 1 2 neg 3 range|
 if false then                  |
  "not " ??                     |
 endif "in range" ?             |
                                |
 1 4 3 range "1 4 3 "??         |
 if false then                  |
  "not " ??                     |
 endif                          |
 "in range" ?                   |
                                |
 " 5 10 max min " ?             |
 10 5 max ?                     |
 5 10 min ?                     |
                                |
 3 neg ?                        |
 3 not ?                        |
 3 7 and ?                      |
 3 6 or ?                       |
                                |
 " hexadec of 100 "?? 100 hex ? |
 " octal of 64    "?? 64  oct ? |
 " binary of 62   "?? 62  bin ? |
 ""?                            |
 "Binary formats:"?             |
 0x100?                         |
 0o100?                         |
 0b100?                         |
|-------------------------------|
 ""?"floating point:"?          |
 12345.6789e2 ?                 |
 12345.6789e-2 ?                |
                                |
 ""? ?                          |
 "Date: "?? date?               |
 "Time: "?? time?               |
 ""? "shell:"?                  |
 "dir" shell                    |
                                |
"" ? ?                          |
|-------------------------------|

 "read these words 
  (using the internal reader)"?

|-------------------------------|
 read                           |
 (                              |
  word                          |
  if be then ? repeat endif     |
 )                              |
 "[End of line.]"?              |
                                |
                                |
|-------------------------------|
                                |
 "hello" : sabrina              |
 ""?                            |
 "sabrina" exist                |
 if true then                   |
  "sabrina exists" ?            |
 endif                          |
 "gizmodo" exist                |
 if true then                   |
  "gizmodo exists" ?            |
 endif                          |
                                |
|-------------------------------|
                                |
)                               | deallocate stack
                                |
                                |
                                |
                                |
|-------------------------------|
"" ? "Error tests"?             |
|===============================|
|                               |
| nagadoo                       | not found
| ))))                          | error 19 
| ++++                          | 
| pop                           |
| 4 rets                        | error 22
| end                           | error 22
| :nagadoo nagadoo.aa           |
| 1 0 / ?                       | 1#inf
|  degrees 90 tan ?             | 3499999887553390
                                |
                                |
                                |
|-------------------------------|
"" ? "end of tests"?            |
|===============================|

