

' 1-17 Sept 2007
' Charles E V Pegge
' Experimenting with postfix notation




'-----------------------------------'
' CONSTANTS                         '
'-----------------------------------'
                                    '
 #define PARAMAX  1000              ' variables stack size
 #define VBS      100               ' Start of param stack (above reserved area)
 #define BRKDEPTH 100               ' Bracket index stack size
 #define FUNDEPTH 100               ' Return addresses stack size
                                    '
'-----------------------------------'
' STRUCTURES                        '
'-----------------------------------'

union compat
 bv as ubyte
 lv as long
 sv as single
 dv as double
 bp as ubyte  ptr
 lp as long   ptr
 sp as single ptr
 dp as double ptr
end union
                                    '
'-----------------------------------'
' ARRAYS                            '
'-----------------------------------'
                                    '
 dim shared vsi(PARAMAX)  as long   ' variable mode
 dim shared vcd(PARAMAX)  as double ' numeric variable
 dim shared vcz(PARAMAX)  as string ' string variable
 dim shared vaz(PARAMAX)  as string ' string variable name
 dim shared brk(BRKDEPTH) as long   ' brackets stack
 dim shared cbr(BRKDEPTH) as long   ' block location stack
 dim shared blr(BRKDEPTH,1) as long ' block exits link stack
 dim shared ifs(BRKDEPTH) as long   ' if..endif link stack
 dim shared cfn(FUNDEPTH) as long   ' function return address stack
 dim shared cfs(FUNDEPTH) as long   ' function return string stack
 dim shared cvb(FUNDEPTH) as long   ' function return local vars top
 dim shared cpb(FUNDEPTH) as long   ' function return svar tack ptr
 dim shared cbk(FUNDEPTH) as long   ' function return bracket stack
 dim shared ths(FUNDEPTH) as long   ' 'this' object stack
                                    '
'-----------------------------------'
' MAIN VARIABLES                    '
'-----------------------------------'
                                    '
 dim shared pxi as long             ' previouse word ascii
 dim shared lxi as long             ' current word ascii
 dim shared nxi as long             ' next word ascii
 dim shared lsi as long             ' length of string to parse
 dim shared cwi as long             ' current word position
 dim shared ewi as long             ' end of word position
 dim shared ipi as long             ' current reading position for next word
 dim shared jpi as long             ' reserved reading position for next word
 dim shared lwi as long             ' length of word
 dim shared opi as long             ' operator flag
 dim shared opp as long             ' interpreted operator flag
 dim shared pai as long             ' variables stack index
 dim shared pvi as long             ' max declared vars stack index
 dim shared bri as long             ' brackets param and block stack index
 dim shared ifi as long             ' if links index
 dim shared cfi as long             ' return address stack index
 dim shared ari as long             ' array index
 dim shared ost as long             ' object property start postion
 dim shared ond as long             ' object property end boundary
 dim shared ott as long             ' object property / method type
 dim shared cst as long             ' code string index
 dim shared sgs as long             ' sign & zero flag for math and logical ops
 dim shared nrf as long             ' flag to prevent referencing
 dim shared nar as long             ' flag to prevent array offset
 dim shared fbp as long             ' first bracketed param index
 dim shared lbp as long             ' last bracketed param index
 dim shared ars as long             ' array flag / quantity pf elements
 dim shared typ as long             ' type code
 dim shared tof as long             ' compund type offset accum
 dim shared rst as long             ' reading string
 dim shared rpc as long             ' reading current word position
 dim shared rpn as long             ' reading next word position
 dim shared chn as long             ' print / file output channel

 dim shared dtr as double:          dtr=atn(1)/45  ' degrees to radians
 dim shared rtd as double:          rtd=45/atn(1)  ' radians to degrees
 dim shared deg as double:          deg=1          ' degrees conversion factor
 dim shared rad as double:          rad=1          ' radians conversion factor

 dim shared tys as string           ' type string for compound types
 dim shared dat as string           ' data string for compound types

 dim shared vc  as compat           ' for type conversion / pointers etc

                                   '                                    '

'==================================='
' EXTRACT WORDS AND SYMBOLS         '
'-----------------------------------' initial
function words()as string           '
 dim c as ubyte                     '
 pxi=lxi                            '
 opi=0                              '
 lxi=0                              '
 nxi=0                              '
 lwi=0                              '
'-----------------------------------' skip spaces
 do                                 '
  if ipi>lsi then c=0:exit do       '
  c=asc(vcz(cst),ipi)                      '
  if c>32 then exit do              '
  ipi+=1                            '
 loop                               '
'-----------------------------------'
 cwi=ipi                            ' start of word
 lxi=c                              ' ascii of word
'-----------------------------------'
 do                                 '
  if ipi>lsi then exit do           '
  c=asc(vcz(cst),ipi)                      '
  if c<=32 then exit do             '
  if (c=34)or(c=39) then            ' quoted string
   ipi=instr(ipi+1,vcz(cst),chr$(c))       '
   if ipi=0 then ipi=lsi+1          '
   opi=3                            '
   ipi+=1                           '
   exit do                          '
  end if                            '
'-----------------------------------'
  if c=46 then                      '
   if ipi>cwi then                  '
    if (lxi<48)or(lxi>57) then      ' dotted name split
     exit do                        '
    end if                          '
   end if                           '
  end if                            '
'-----------------------------------'
  if (c=40)or(c=41)or(c=43)or(c=45)_' ()+-   self delimiting symbols
  or(c=42)or(c=47)or(c=38)or(c=58)_ ' */&:
  or(c=60)or(c=63)or(c=36)or(c=96)_ ' <?$`
  or(c=94)_                         ' ^
  then                              '
   if ipi=cwi then ipi+=1: opi=c    '
   exit do                          '
  end if                            '
  if c=124 then                     ' comment
   ipi=instr(ipi+1,vcz(cst),chr$(10))      '
   if ipi=0 then ipi=lsi+1          '
   continue do                      '
  end if                            '
  if c<220 then ipi+=1:continue do  '
'-----------------------------------'
  if c>=250 then                    ' binary dquad attached
    if ipi=cwi then ipi+=17: opi=c   '
    exit do                         '
  end if                            '
  if c>=240 then                    ' binary quad attached
    if ipi=cwi then ipi+=9: opi=c   '
    exit do                         '
  end if                            '
  if c>=230 then                    ' binary long attached
   if ipi=cwi then ipi+=5: opi=c    '
   exit do                          '
  end if                            '
  if c>=220 then                    ' binary short attached
   if ipi=cwi then ipi+=3: opi=c    ' 
   exit do                          '
  end if                            '
  if c>=210 then                    ' byte attached
   if ipi=cwi then ipi+=2: opi=c    ' 
   exit do                          '
  end if                            '
 loop                               '
'-----------------------------------'
 ewi=ipi                            ' word boundary
 lwi=ewi-cwi                        ' length of word
'-----------------------------------'find start of next word
 do                                 '
  if ipi>lsi then exit do           '
  c=asc(vcz(cst),ipi)                      '
  if c=124 then                     ' skip comment
   ipi=instr(ipi+1,vcz(cst),chr$(10))      '
   if ipi=0 then ipi=lsi+1          '
   continue do                      '
  end if                            '
  if c>32 then nxi=c:exit do        ' ascii of next word
  ipi+=1                            '
 loop                               '
'-----------------------------------'
 function=mid$(vcz(cst),cwi,lwi)           '
end function                        '
'==================================='



'==================================='
' PUSH VARIABLES ONTO STACK         '
'==================================='
function pushvar(i as long) as long '
 pai+=1                             '
 vsi(pai)=vsi(i)                    '
 vcd(pai)=vcd(i)                    '
 vcz(pai)=vcz(i)
 vaz(pai)=""                        '
 function=0                         '
end function                        '
'==================================='




'==================================='
' PUSH RETURN DATA ONTO STACKS      '
'==================================='
function pushret(i as long) as long '
 cfi+=1                             ' increment call stacks pointer
 cfn(cfi)=ipi                       ' save the return address
 cfs(cfi)=cst                       ' save the return string index
 cvb(cfi)=pvi                       ' save local var top
 cpb(cfi)=pai                       ' save var stack index
 cbk(cfi)=bri                       ' save bracket stack index
 ths(cfi)=i                         ' record 'this' object
 function=0                         '
end function                        '
'==================================='




'==================================='
' RETURN FROM A FUNCTION OR METHOD  '
'==================================='
function returns() as long          '
 ipi=cfn(cfi)                       ' restore code pointer
 cst=cfs(cfi)                       ' restore string index
 pvi=cvb(cfi)                       ' restore local var top
 pai=cpb(cfi)                       ' restore var stack
 bri=cbk(cfi)                       ' restore bracket stack index
 cfi-=1                             ' decreement the call stacks pointer
 lsi=len(vcz(cst))                  ' restore boundary
 if cfi<0 then                      '
  function=17:exit function         '
 end if                             '
 function=0                         '
end function                        '
'==================================='




                               '
'======================================'
' DEREFERENCE VARIABLES ETC            '
'======================================'
function deref(byval i as long) as long'
 dim v as long                         ' offsets for properties and methods
 dim d as long                         ' depth
 dim td as long                        ' target depth
 dim w as string                       ' word
 if (vsi(i)<0)and(nrf=0) then          ' dereferencing
  do                                   '
   i=-vsi(i)                           '
   if i>pvi then                       '
    function=0:exit function           ' errpr 16 pointing to a disallocated variable error
   end if                              '
   if vsi(i)>=0 then exit do           '
  loop                                 ' continue reference tracing
 end if                                '
 if nar=0 then i+=ari:ari=0            ' add array index if any                              '
 nrf=0: nar=0                          ' clear deref and array inhibit flags
'--------------------------------------'
' is it normal var or is it an object? '
'--------------------------------------'
 if i then                             ' do this only if a string variable was located
  if (vsi(i)=2)and(nxi=46) then        ' is dotted variable lookup
   w="<"+mid$(words(),2)+">"           ' next part of name and
   td=1                                ' target depth
   v=0                                 ' test index
   d=0                                 ' depth
   otp=0                               ' type of object
   do                                  ' traverse object tracking the depth
    v=instr(v+1,vcz(i),"<")            ' find next tag mark
    if v=0 then exit do                ' not successful
    if asc(vcz(i),v+1)=47 then         ' its an end tag
     d-=1: continue do                 ' decrease depth and continue
    end if                             '
    d+=1                               ' otherwase increase the depth
    if d=td then                       ' if the depth matches
     if mid$(vcz(i),v,len(w))=w then   ' try matching the name segment
      if nxi<>46 then exit do          ' there are no more name segments so success
      w="<"+mid$(words(),2)+">"        ' set up the next name segment
      td+=1                            ' and its target depth
     end if                            '
    end if                             '
   loop                                ' continue tracking
   if v then                           ' if the property/method was located
    v+=len(w)                          ' look at the contents
    lxi=asc(vcz(i),v)                  ' first byte indicating tyoe
    do                                 ' cases of object type
     if lxi=32 then ott=32: exit do    ' string
     if lxi=35 then ott=35: exit do    ' number
     if lxi=33 then ott=33: exit do    ' method
     ott=32:exit do                    ' default type as string
    loop                               ' end of cases
    ost=v                              ' start of object
    ond=len(vcz(i))+1                  ' but try to capture just the nested object
    do                                 ' trace tags forward
     v=instr(v+1,vcz(i),"<")           ' locate next tag mark
     if v=0 then exit do ' no more     '
     if asc(vcz(i),v+1)=47 then        '
      d-=1                             ' reduce depth
      if d<td then ond=v: exit do      ' marks the end of the proerty / method
      continue do                      ' next tag mark
     end if                            '
     d+=1                              ' increase depth
    loop                               ' next tag mark
   end if                              ' object's property / method located
   if ost=0 then i=0                  ' indicate object not found
  end if                               ' dotted names
 end if                                ' located variable
'--------------------------------------'
 function=i                            ' return index or 0
end function                           '
'======================================'





'======================================'
' LOOKUP VARIABLES                     '
'======================================'
function lookup(w as string) as long   '
 dim i as long                         ' index of variable
 i=pvi                                 ' top of named variable list
 ost=0                                 ' start of an object's component
 if w="this" then                      '
  function=deref(ths(cfi))             '
  exit function                        '
 end if                                '
 do                                    ' try to find the variable
  if i<VBS then                        '
   print w;"  not found"               ' not found error ?
   function=0: exit function           '
  end if                               '
  if w=vaz(i) then exit do             '
  i-=1                                 '
 loop                                  '
 function=deref(i)                     '
end function                           '
'======================================'




'======================================'
' INTERPRETER                          '
'--------------------------------------'
function interpret(t as string) as long'
'--------------------------------------'
                                       '
 dim w as string                       ' for words or symbols
 dim as long h,i,j,k                   ' general purpose
 dim v as long                         '
                                       '
'--------------------------------------'
' INITIAL                              '
'--------------------------------------'
 cst=VBS-1                            '
 vcz(cst)=t                            '
 pai=VBS                               '
 pvi=VBS-1                             '
 ipi=1                                 '
 lsi=len(vcz(cst))                     '
'--------------------------------------'
' main loop                            '
'--------------------------------------'
 do                                    '
  w=words()                            ' get the next word
  if lwi=0 then exit do                ' reached end of source
  if (lxi>47)and(lxi<58) then opi=1    ' number
  if (lxi>64)and(lxi<91) then opi=2    ' alpha uppercase
  if (lxi>96)and(lxi<123) then opi=2   ' alpha lowercase
                                       '
'--------------------------------------'
' identify and act                     '
  opp=opi                              '
'--------------------------------------'
  if opp=1 then                        ' literal numeric
   v=asc(w,lwi)                        '
   if (v=&h45)or(v=&h65) then          '
    if asc(vcz(cst),cwi+lwi)=45 then   '
     ipi+=1:w+="-"+words()             ' 123e-something
    end if                             '
   end if                              '
   if lwi>2 then                       '
    v=asc(w,2)                         '
    if v>57 then mid$(w,1)="&"         ' 0x.. 0o.. 0q. 0b.. to & basic format
    if (v=&h58)or(v=&h78) then         '
     mid$(w,2)="h"                     '
    end if                             '
   end if                              '
   pai+=1:vcd(pai)=val(w):vsi(pai)=1   ' push num onto stack
  end if                               '
'--------------------------------------'
  if opp=3 then                        ' quoted text
   pai+=1:vcz(pai)=mid$(w,2,lwi-2)     ' push onto stack
   vsi(pai)=2                          ' type string
  end if                               '
'--------------------------------------'
  if opp=2 then                        ' commands functions or variables
   do ' case                           '
'--------------------------------------'
    if w="args" then                   '
     v=vcd(pai)                        ' get the number of params
     pai=pai-v                         ' point to the first param
     cpb(cfi)=pai-1                    ' adjust stored var stack ptr
     exit do                           '
    end if                             '
'--------------------------------------'
    if w="inc" then                    ' 
     i=lookup(words())                 '
     if i then                         '
      if vsi(i)=1 then vcd(i)+=1       ' does not affect the stack
     end if                            '
     sgs=sgn(vcd(i))                   '
     exit do                           '
    end if                             '
'--------------------------------------'
    if w="dec" then                    '
     i=lookup(words())                 '
     if i then                         '
      if vsi(i)=1 then vcd(i)-=1       ' does not affect the stack
     end if                            '
     sgs=sgn(vcd(i))                   '
     exit do                           '
    end if                             '
'--------------------------------------'
    if w="len" then                    '
     pai+=1:vsi(pai)=1:vcd(pai)=0      '
     i=deref(pai-1)                    '
     if i then                         '
      if vsi(i)=1 then vcd(pai)=8      '
      if vsi(i)=2 then                 '
       vcd(pai)=len(vcz(i))            '
      end if                           '
      vsi(pai)=1                       '
     end if                            '
     sgs=sgn(vcd(i))                   '
     exit do                           '
    end if                             '
'--------------------------------------'
    if w="then" then exit do           ' non exec
'--------------------------------------'
    if w="if" then                     '
     i=pai:if pxi=41 then i=lbp        ' allow for brackets
     w=words()                         '
     if (w="null")or(w="void") then    '
      if vsi(i)=1 then                 '
       if vcd(i)=0 then exit do        '
      end if                           '
      if vsi(i)=2 then                 '
       if vcz(i)="" then exit do       '
      end if                           '
     end if                            '
     if (w="is")or(w="be") then        '
      if vsi(i)=1 then                 '
       if vcd(i)<>0 then exit do       '
      end if                           '
      if vsi(i)=2 then                 '
       if vcz(i)<>"" then exit do      '
      end if                           '
     end if                            '
     v=sgs                             '
     if v=0 then                       '
      if w="false" then exit do        '
      if w="EQ" then exit do           '
      if w="LE" then exit do           '
      if w="GE" then exit do           '
     end if                            '
     if v>0 then                       '
      if w="true" then exit do         '
      if w="GT" then exit do           '
      if w="GE" then exit do           '
      if w="NE" then exit do           '
     end if                            '
     if v<0 then                      '
      if w="true" then exit do         '
      if w="LT" then exit do           '
      if w="LE" then exit do           '
      if w="NE" then exit do           '
     end if                            '
     v=1                               ' skip this clause and its inner clauses
     do                                '
      w=words(): if lwi=0 then exit do ' exit skip loop
      if w="if" then v+=1              '
      if w="endif" then v-=1           '
      if v=0 then exit do              ' skipped if
     loop                              '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="cmp" then                    ' no result assignment
     pai-=1                            ' like other ops +-*/
     i=deref(pai)                      '
     j=deref(pai+1)                    '
     if vsi(pai)=1 then                '
      sgs=sgn(vcd(i)-vcd(j)): exit do  '
     end if                            '
     if vsi(pai)=2 then                '
      sgs=0                            '
      if vcz(i)>vcz(j) then            '
       sgs=1: exit do                  '
      end if                           '
      if vcz(i)<vcz(j) then            '
       sgs=-1:  exit do                '
      end if                           '
     end if                            '
     exit do                           '
    end if                             '
'--------------------------------------'
    if w="def" then                    ' log and skip defs
     w=words()                         '
     pai+=1: vcd(pai)=ipi              ' push onto stack as a function
     vaz(pai)=w: vsi(pai)=3            ' 3 for functions
     if cst<>VBS-1 then vsi(pai)=4     ' a local def within an object's method
     pvi=pai                           ' update var top
     v=1                               ' support nestable defs
     do                                ' skip def
      w=words()                        ' next word
      if lwi=0 then exit do            ' end of source
      if w="def" then v+=1             ' start of nested functiom
      if w="end" then v-=1             '
      if v=0 then exit do              ' end of function
     loop                              ' end skip def
     exit do                           ' cases exit
    end if                             '
'--------------------------------------'
' end or exit                          '
'--------------------------------------'
    if w="endif" then exit do          '
'--------------------------------------'
    if w="exit" then                   ' exit from block
     v=bri                             ' skip this clause and its inner clauses
     do                                '
      w=words()                        '
      if lwi=0 then exit do            ' exit skip loop
      if lxi=40 then                   '
       v+=1
      end if                           '
      if lxi=41 then                   '
       v-=1             '
      end if                           '
      if v<bri then
       pai=brk(v+1): bri=v: exit do    ' skipped block
      end if
     loop                              '
     exit do ' exit cases              '
    end if                             ' end of end do
'--------------------------------------'
    if w="end" then returns(): exit do ' end of function
'--------------------------------------'
    if w="rets" then                   ' exit from function
     v=vcd(pai)                        ' number of items to return
     returns()                         '
     pai+=v                            ' returned params left on stack
     exit do                           ' exit cases
    end if                             ' end of end def
'--------------------------------------'
    if w="go" then                     ' goto past word
     w="#"+words():v=bri               ' scan forwards ignoring inner blocks
     do                                '
      if lwi=0 then exit do            ' exit skip loop
      if lxi=40 then v+=1
      if lxi=41 then v-=1              '
      if w=words() then
       if v<=bri  then   '
        if v<bri then bri=v:pai=brk(bri+1)
        exit do                         '
       end if
      end if                           '
     loop                              '
     exit do                           ' exit cases
    end if                             ' end of end def
'--------------------------------------'
    if w="array" then                  ' specify array
     ars=vcd(pai):pai-=1
     exit do                   '
    end if                             '
'--------------------------------------'
    if w="idx" then                    ' index to array
     ari=vcd(pai): pai-=1              '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="pop" then                    ' pop the last var from the stack
     pai-=1: if pai<VBS then pai=VBS   '
     exit do                           '
    end if                             '
'--------------------------------------'
    if w="load" then                   ' load a prog
     ERR=0                             '
     open vcz(pai) for input as 1      '
     if ERR then                       '
      function =21: exit function      ' file not available error
     end if                            '
     close #1                          '
     open vcz(pai) for binary as 1     '
     v=lof(1)                          '
     t=space$(v)                       '
     get$ #1,,t                        '
     close #1                          '
     vcz(cst)+=t                              '
     lsi=len(vcz(cst))                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="repeat" then                 ' block repeat
     if bri then
      ipi=cbr(bri)                     '
      pai=brk(bri)                     ' deallocate vars
      exit do                          ' exit cases
     end if
    end if                             '
'--------------------------------------'
    if w="ref" then                    ' by reference
     w=words()                         '
     pai+=1:vsi(pai)=-lookup(w)        ' for passing variables by reference
     exit do                           '
    end if                             '
'--------------------------------------'
    if w="mov" then nrf=1:goto tto     ' ignoring deref stage
    if w="to" then                     ' assign
tto:                                   '
     i=lookup(words())                 '
     if i then                         '
      if ost then                      '
       w=""                      '     '
       if vsi(pai)=1 then              '
        vcz(pai)=str$(vcd(pai)):w="#"  ' numbers otherwise string or method
       end if                          '
       if vsi(pai)=2 then              '
        if asc(vcz(pai))<>33 then w=" "'
       end if                          '
       vcz(i)=mid$(vcz(i),1,ost)_      '
       +w+vcz(pai)+mid$(vcz(i),ond)    '
       exit do                         '
      end if                           '
      vsi(i)=vsi(pai)                  '
      vcd(i)=vcd(pai)                  '
      vcz(i)=vcz(pai)                  '
     end if                            '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="swap" then                   '
     swap vcz(pai-1),vcz(pai)          '
     swap vcd(pai-1),vcd(pai)          '
     swap vsi(pai-1),vsi(pai)          '
     exit do                           '
    end if                             '
'--------------------------------------'
    if w="state" then                  ' store state a set locations
     vcd(1)=pai:vsi(1)=1               ' var stack pointer
     vcd(2)=cfi:vsi(2)=1               ' fun stack pointer
     vcd(3)=bri:vsi(3)=1               ' bracket stack pointer
     vcd(4)=bri:vsi(4)=1               ' 
     vcd(5)=ipi:vsi(5)=1               ' instruction pointer
     vcd(6)=lsi:vsi(6)=1               ' length of instruction string
     vcd(7)=cst:vsi(7)=1               ' instruction string
     vcd(8)=ths(cst):vsi(8)=1          ' "this" string
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
' low level types                      '
'--------------------------------------'
    if w="type" then                   ' convert compound variable into a type
     typ=typ or &h10000                '
     vsi(pai)=vsi(pai) or &h10000      '
    end if                             '
'--------------------------------------'
    if w="comp" then                   ' compound or union ? affects offsets only
     tys="":dat="":tof=0               ' init field descriptor and data
     i=fbp                             '
     do                                '
      if i>lbp then exit do            ' end of vpmpound
      if vsi(i)=2 then                 ' specimen type
       dat+=mkd$(vcd(i)):v=8           ' for double data
      end if                           '
      tys+=_                           '
      mkl$(vsi(i))+mkl$(tof)+mkl$(v)_  '
      +chr$(len(vaz(i)))+vaz(i)        '
                                       ' accummulate structure
      tof+=v                           ' update the offset
      i+=1                             ' next element
     loop                              ' repeat
     pai+=1                            ' next stack place
     vsi(pai)=&h61                     ' type as 'a' for compund 
     vaz(pai)=""                       ' clear the name
     vcz(pai)=mkl$(len(tys))+tys+dat   ' store the descriptor and the data 
                                       ' todo access with dotted notation
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="exist" then                  '
     w=vcz(pai)                        '
     i=pvi: sgs=0                      '
     do                                '
      if i<VBS then exit do            '
      if w=vaz(i) then                 '
       sgs=deref(i): exit do           '
      end if                           '
      i-=1                             '
     loop                              '
     exit do                           '
    end if                             '
'--------------------------------------'
    if w="ptr" then                    '
     w=words()                         ' ptr
     if typ then                       '
      typ=(typ and &hffffffdf)         ' pointer flag upper case
     end if                            '
     exit do                           '
    end if                             '
'--------------------------------------'
    if w="long" then                   '
     typ=&h6c                          '
     if nxi=58 then pai+=1
     exit do                           '
    end if                             '
    if w="single" then                 '
     exit do                           '
    end if                             '
    if w="double" then                 '
     exit do                           '
    end if                             '
    if w="byte" then                   '
     exit do                           '
    end if                             '
    if w="string" then                 '
     if nxi=58 then pai+=1
     exit do                           '
    end if                             '
    if w="stdcall" then                '
     exit do                           '
    end if                             '
    if w="cdecl" then                  '
     exit do                           '
    end if                             '
    if w="library" then                 '
     exit do                           '
    end if                             '
    if w="libfun" then                 '
     exit do                           '
    end if                             '
'======================================'
' built-in functions                   '
'======================================'
'
'--------------------------------------'
' STRING FUNCTIONS                     '
'--------------------------------------'
    if w="asc" then                    ' get ascii code from char in a string
     pai-=1                            '
     i=deref(pai)                      '
     j=deref(pai+1)                    '
     if i=0 then exit do               '
     vcd(pai)=asc(vcz(i),vcd(j))       '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="chr" then                    ' convert asci to character
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcz(pai)=chr$(vcd(i))             '
     vsi(pai)=2                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="ltrim" then                  ' trim left spaces
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcz(pai)=ltrim$(vcz(i))           '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="rtrim" then                  ' trim right spaces
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcz(pai)=rtrim$(vcz(i))           '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="lower" then                  ' lowercase
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcz(pai)=lcase$(vcz(i))           '
     vsi(pai)=2                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="upper" then                  ' uppercase
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcz(pai)=ucase$(vcz(i))           '
     vsi(pai)=2                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="mid" then                    '
     pai-=2                            '
     i=deref(pai)                      '
     if i=0 then exit do               '
     j=deref(pai+1)                    '
     k=deref(pai+2)                    '
     vcz(pai)=mid$(vcz(i),vcd(j),vcd(k))
     vsi(pai)=2                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="midl" then                    '
     pai-=2                            '
     i=deref(pai)                      '
     if i=0 then exit do               '
     j=deref(pai+1)                    '
     k=deref(pai+2)                    '
     vcz(pai)=mid$(vcz(i),vcd(j),_
     vcd(k)-vcd(j))                    '
     vsi(pai)=2                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="insert" then                 '
     pai-=3                            '
     h=deref(pai)                      '
     if h=0 then exit do               '
     i=deref(pai+1)                    '
     j=deref(pai+2)                    '
     k=deref(pai+3)                    '
     vcz(h)=mid$(vcz(h),1,vcd(j)-1)_   '
     +vcz(i)+mid$(vcz(h),vcd(k))       '
     exit do                           ' exit cases
    end if                             '
'-'--------------------------------------'
    if w="patch" then                  '
     pai-=2    '
     i=deref(pai)                      '
     if i=0 then exit do               '
     j=deref(pai+1)                    '
     k=deref(pai+2)                    '
     mid$(vcz(i),vcd(k))=vcz(j)        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="pos" then                    '
     pai-=2                            '
     i=deref(pai)                      '
     if i=0 then exit do               '
     j=deref(pai+1)                    '
     k=deref(pai+2)                    '
     vcd(pai)=instr(vcd(k),vcz(i),vcz(j)) '
     vsi(pai)=1             '          '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="hex" then                    ' hexadecimal
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcz(pai)=hex$(vcd(i)):vsi(pai)=2  '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="oct" then                    ' octal
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcz(pai)=oct$(vcd(i)):vsi(pai)=2  '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="bin" then                    ' binary
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcz(pai)=bin$(vcd(i)):vsi(pai)=2  '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="str" then                    '
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcz(pai)=str$(vcd(i)):vsi(pai)=2  '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="many" then                   ' repeating string elements
     pai-=1                            '
     i=deref(pai)                      '
     j=deref(pai+1)                    '
     if i=0 then exit do               '
     w=vcz(i):v=len(w)*vcd(j)          '
     vcz(pai)=string$(v," ")           '
     vsi(pai)=2                        '
     if v=0 then exit do               '
     i=1: j=len(w)                     '
     do                                '
      if i>v then exit do              '
      mid$(vcz(pai),i)=w:i+=j          '
     loop                              '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="read" then                   '
     i=deref(pai)                      '
     rst=i:rpc=0:rpn=1                 '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="word" then                   '
     swap rpc,cwi:swap rpn,ipi         '
     swap cst,rst                      '
     pai+=1:vcz(pai)=words():vsi(pai)=2 '
     swap rpc,cwi:swap rpn,ipi         '
     swap cst,rst                      '
     lxi=0                             '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="val" then                    '
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=val(vcz(i)):vsi(pai)=1   '
     exit do                           ' exit cases
    end if                             '
                                       '
'--------------------------------------'
    if w="date" then                    '
     pai+=1:vcz(pai)=date$:vsi(pai)=2  '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="time" then                    '
     pai+=1:vcz(pai)=time$:vsi(pai)=2  '
     exit do                           ' exit cases
    end if                             '
                                       '
'--------------------------------------'
' CONSOLE FUNCTIONS                    '
'--------------------------------------'
    if w="getkey" then                 '
     pai+=1:vcz(pai)=inkey$:vsi(pai)=2 '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="getline" then                '
     i=deref(pai)                      '
     line input$ vcz(i),vcz(pai)       '
     vsi(pai)=2                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="color" then                  '
     pai-=2                            '
     i=deref(pai+1)                    '
     j=deref(pai+2)                    '
     color vcd(i),vcd(j)               '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="cls" then                    '
     CLS                               '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="locate" then                 '
     pai-=3                            '
     i=deref(pai+1)                    '
     j=deref(pai+2)                    '
     k=deref(pai+3)                    '
     locate vcd(i),vcd(j),vcd(k)       '
     vsi(pai)=2                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
' SYSTEM FUNCTIONS                     '
'--------------------------------------'
    if w="shell" then                  '
     shell vcz(pai)                    '
     exit do                           ' exit cases
    end if                             '
                                       '
'--------------------------------------'
' FILE FUNCTIONS                       '
'--------------------------------------'
    if w="file" then                   '
     i=deref(pai)                      '
     v=freefile                        '
     ERR=0                             '
     open vcz(i) for binary as v       '
     sgs=ERR                           '
     vcd(pai)=v: vsi(pai)=1            '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="filein" then                 '
     i=deref(pai)                      '
     v=freefile                        '
     ERR=0                             '
     open vcz(i) for input as v        '
     sgs=ERR                           '
     vcd(pai)=v: vsi(pai)=1            '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="fileout" then                '
     i=deref(pai)                      '
     v=freefile                        '
     ERR=0
     open vcz(i) for output as v       '
     chn=v                             ' set o/p channel
     sgs=ERR                           '
     vcd(pai)=v: vsi(pai)=1            '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="out" then                    '
     pai-=2                            '
     i=deref(pai+1)                    '
     j=deref(pai+2)                    '
     ERR=0                             '
     print #vcd(i),vcz(j)              '
     chn=vcd(i)                        ' set o/p channel
     sgs=ERR                           '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="eof" then                     '
     i=deref(pai)                      '
     ERR=0                             '
     vcd(pai)=eof(vcd(i))              '
     sgs=ERR                           '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="loc" then                     '
     i=deref(pai)                      '
     ERR=0                             '
     vcd(pai)=loc(vcd(i))              '
     sgs=ERR                           '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="lof" then                     '
     i=deref(pai)                      '
     ERR=0                             '
     vcd(pai)=lof(vcd(i))              '
     sgs=ERR                           '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="in" then                     '
     i=deref(pai)                      '
     ERR=0                             '
     line input # vcd(i),vcz(pai)      '
     sgs=ERR                           '
     vsi(pai)=2                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="get" then                    '
     i=deref(pai)                      '
     ERR=0                             '
     pai-=1                            '
     i=deref(pai)                      '
     j=deref(pai+1)                    '
     v=lof(vcd(i))-loc(vcd(i))         '
     if vcd(j)<v then v=vcd(j)         '
     vcz(pai)=string$(v,chr$(0))       '
     ERR=0                             '
     GET$ #vcd(i),,vcz(pai)            '
     sgs=ERR                             '
     vsi(pai)=2                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="seek" then                   '
     pai-=2                            '
     i=deref(pai+1)                    '
     j=deref(pai+2)                    '
     ERR=0                             '
     SEEK #vcd(i),vcd(j)               '
     sgs=ERR                           '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
   if w="lock" then                    '
     pai-=3                            '
     i=deref(pai+1)                    '
     j=deref(pai+2)                    '
     k=deref(pai+4)                    '
     ERR=0                             '
     LOCK #vcd(i),vcd(j) TO vcd(k)     '
     sgs=ERR                           '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
   if w="unlock" then                    '
     pai-=3                            '
     i=deref(pai+1)                    '
     j=deref(pai+2)                    '
     k=deref(pai+4)                    '
     ERR=0                             '
     UNLOCK #vcd(i),vcd(j) TO vcd(k)   '
     sgs=ERR                           '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
   if w="put" then                    '
     pai-=2                            '
     i=deref(pai+1)                    '
     j=deref(pai+2)                    '
     ERR=0                             '
     PUT$ #vcd(i),,vcz(j)              '
     sgs=ERR                           '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="close" then                  '
     i=deref(pai)                      '
     close vcd(i)                      '
     if chn=vcd(i) then chn=0          ' close o/p channel
     pai-=1                            '
     exit do                           ' exit cases
    end if                             '
                                       '
'--------------------------------------'
' LOGIC % NUMERIC FUNCTIONS            '
'--------------------------------------'
'--------------------------------------'
    if w="and" then                    ' bitwise and
     pai-=1                            '
     i=deref(pai)                      '
     j=deref(pai+1)                    '
     if i=0 then exit do               '
     vcd(pai)=vcd(i) and vcd(j)        '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="or" then                     ' bitwise or
     pai-=1                            '
     i=deref(pai)                      '
     j=deref(pai+1)                    '
     if i=0 then exit do               '
     vcd(pai)=vcd(i) or vcd(j)         '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="xor" then                    ' bitwise xor
     pai-=1                            '
     i=deref(pai)                      '
     j=deref(pai+1)                    '
     if i=0 then exit do               '
     vcd(pai)=vcd(i) xor vcd(j)        '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="not" then                    ' not / bit inversion
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=not(vcd(i))              '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="abs" then                    ' absolute value
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=abs(vcd(i))              '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="fix" then                    ' fix
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=fix(vcd(i))              '
      vsi(pai)=1                       '
      exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="frac" then                   ' frac
     i=deref(pai)                      '
     if i=0 then exit do               '
      vcd(pai)=vcd(i)-int(vcd(i))    '
      vsi(pai)=1                       '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="int" then                    ' integer
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=int(vcd(i))              '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="round" then                  ' rounding
     pai-=1                            '
     i=deref(pai)                      '
     j=deref(pai+1)                    '
     if i=0 then exit do               '
     vcd(pai)=_
     int(vcd(i)*10^vcd(j)+.5)/(10^vcd(j))
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="sgn" then                    ' sign
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=sgn(vcd(i))              '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="neg" then                    ' negate / reverse sign
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=-(vcd(i))                '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="mod" then                    ' modulus floating point
     pai-=1                            '
     i=deref(pai)                      '
     j=deref(pai+1)                    '
     if i=0 then exit do               '
     vcd(pai)=vcd(i)_                  '
     -int(vcd(i)/vcd(j))*vcd(j)        '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="sqr" then                    ' square root
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=sqr(vcd(i))              '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="log" then                    ' natural log
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=log(vcd(i))              '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="exp" then                    ' exponent
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=exp(vcd(i))              '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="min" then                    ' minimum of 2
     pai-=1                            '
     i=deref(pai)                      '
     j=deref(pai+1)                    '
     if i=0 then exit do               '
     vcd(pai)=_
     IIF(vcd(i)<vcd(j),vcd(i),vcd(j))  '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="max" then                    ' maximum of 2
     pai-=1                            '
     i=deref(pai)                      '
     j=deref(pai+1)                    '
     if i=0 then exit do               '
     vcd(pai)=_
     IIF(vcd(i)>vcd(j),vcd(i),vcd(j))  '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="range" then                  ' within range?
     pai-=3                            '
     i=deref(pai+1)                    '
     j=deref(pai+2)                    '
     k=deref(pai+3)                    '
     if i=0 then exit do               '
     sgs=0                             '
     if (vcd(i)<=Vcd(j))_              '
     and(vcd(j)<=vcd(k)) then sgs=1    '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="rnd" then                    ' random
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=rnd(vcd(i))              '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="randomize" then              ' seed randomiser
     randomize                         '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="degrees" then                ' trig in degrees
     deg=rtd:rad=dtr                   '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="radians" then                ' trig in radians
     deg=1:rad=1                       '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="cos" then                    ' cosine
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=cos(vcd(pai)*rad)        '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="sin" then                    ' sine
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=sin(vcd(pai)*rad)        '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
    if w="tan" then                    ' tangent
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=tan(vcd(pai)*rad)        '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
   if w="atn" then                     ' arctangent
     i=deref(pai)                      '
     if i=0 then exit do               '
     vcd(pai)=atn(vcd(pai))*deg        '
     vsi(pai)=1                        '
     exit do                           ' exit cases
    end if                             '
'--------------------------------------'
' WORD NOT UDENTIFIED YET?             '
' search for variables and functions   '
'--------------------------------------'
                                       '
    i=lookup(w)                        '
    if i then                          ' was located
     if ost then                       ' was a dotted member
      if (ott=32)or(ott=33) then       ' string or code
       v=asc(vcz(i),ost)               ' check type byte
       if (v=32)or(v=33) then          '
        ost+=1                         ' omit the type byte
       end if                          '
       if ott=33 then                  ' a method
        pushret(i)                     ' stack return address etc
        ipi=ost                        ' set calling address
        cst=i                          ' set calling string
        lsi=len(vcz(cst))              ' update boundary of source
        exit do                        '
       end if                          ' otherwise a string
       pai+=1                          ' make new stack slot
       vcz(pai)=_                      '
       mid$(vcz(i),ost,ond-ost)        '
       vsi(pai)=2                      '
       exit do                         '
      end if                           '
      if ott=35 then                   '
       ost+=1                          ' omit the # byte
       pai+=1                          ' make new stack slot
       vcd(pai)=_                      '
       val(mid$(vcz(i),ost,ond-ost))   '
       vsi(pai)=1                      '
       exit do                         '
      end if                           '
     end if                            '
'--------------------------------------'
     if (vsi(i)=3)or(vsi(i)=4) then    ' call a defined function
      pushret(ths(cst))                ' setup ret addr. also passing on any 'this'
      ipi=vcd(i)                       ' get the function address
      if vsi(i)=3 then cst=VBS-1       ' set the code string index for main code
      lsi=len(vcz(cst))                ' set string boundary
      exit do                          ' exit cases       
     end if                            ' end of function header process
                                       ' otherwise treat as a variable
'--------------------------------------'
     pushvar(i)                        '
     exit do                           ' exit cases
    end if                             ' end of identified word
'--------------------------------------'
    exit do                            ' end of cases
   loop                                ' end of cases do
  end if                               ' end of (opi=2)
                                       '
'--------------------------------------'
  if lxi=35 then                       ' # label - no action
  end if                               '
'--------------------------------------'
  if lxi=64 then                       ' system location var (hi level) or pointer
   v=asc(w,2)                          '
   do                                  '
    if (v>47)and(v<58) then            '
     i=val(mid$(w,2)):pushvar(i)       '
     exit do                           '
    end if                             '
    nar=1:lookup(mid$(w,2))            ' otherwise a pointer so get the value
    if i then                          '
     if vsi(i)=76 then                 ' pointer to long int
      v=ari*4+vcd(i):ari=0             ' add array offset
      asm mov eax,[i]                  ' dereference
      asm mov eax,[eax]                '
      asm mov [v],eax                  '
      pai+=1:vsi(pai)=1:vcd(pai)=v     ' place on stack
      exit do                          '
     end if                            '
    end if                             '
    exit do                            '
   loop                                ' end pointer cases                                    '
  end if                               '
'--------------------------------------'
' identify symbols and act             '
'--------------------------------------'
  if opp >10 then                      '
   do                                  ' cases
                                       '
'--------------------------------------'
                                       '
'--------------------------------------'
    if opp=38 then                     ' absolute address
     i=lookup(words())                 '
     if i=0 then exit do               '
     pai+=1                            '
     if vsi(i)=1 then                  '
      vc.dp=varptr(vcd(i))             '
     end if                            '
     if vsi(i)=2 then                  '
      vc.bp=strptr(vcz(i))             '
     end if                            '
     vsi(pai)=1:vcd(pai)=vc.dv         '
     exit do                           '
    end if                             '
'--------------------------------------'
    if opp=40 then                     ' ( scope
     bri+=1:brk(bri)=pai:cbr(bri)=ipi  '
     exit do                           ' 
    end if                             '
'--------------------------------------'
    if opp=41 then                     ' ) end scope
     lbp=pai                           ' remember the param max index
     pai=brk(bri):bri-=1               '
     fbp=pai+1                         ' assumed first backeted param
     if bri<0 then                     '
      function=19:exit function        ' too many right brackets error
     end if                            '
     exit do                           '
    end if                             '
'--------------------------------------'
    if opp=42 then                     ' * multiply
     vcd(pai-1)*=vcd(pai)              '
     pai-=1: sgs=sgn(vcd(i)): exit do  '
    end if                             '
'--------------------------------------'
    if opp=43 then                     ' + add
     if vsi(pai)=2 then                ' string right concat
      vcz(pai-1)+=vcz(pai)             '
      pai-=1:exit do                   '
     end if                            '
     vcd(pai-1)+=vcd(pai)              '
     pai-=1: sgs=sgn(vcd(pai)): exit do'
    end if                             '
'--------------------------------------'
    if opp=45 then                     ' - subtract
     vcd(pai-1)-=vcd(pai)              '
     pai-=1: sgs=sgn(vcd(pai)): exit do'
    end if                             '
'--------------------------------------'
    if opp=47 then                     ' / divide
     vcd(pai-1)/=vcd(pai)              '
     pai-=1: sgs=sgn(vcd(pai)): exit do'
    end if                             '
'--------------------------------------'
    if opp=94 then                     ' ^ power
     vcd(pai-1)=vcd(pai-1)^vcd(pai)    '
     pai-=1: sgs=sgn(vcd(pai)): exit do'
    end if                             '
'--------------------------------------'
    if opp=58 then                     ' : assign names
     do                                '
      vaz(pai)=words(): pvi=pai        '
      ' if typ then ...
      if ars then                      ' set up array
       i=pai+1                         '
       v=ars+pai-1                     '
       ars=0                           ' clear array flag
       do                              '
        if i>v then exit do            '
        vaz(i)=""                      ' null name
        vsi(i)=vsi(pai)                ' set type etc
        vcd(i)=vcd(pai)
        vcz(i)=vcz(pai)
        i+=1                           '
       loop                            '
       pai=v                           ' update stack ptr
      end if                           '
      if nxi<>58 then exit do          '
      pai+=1:ipi+=1                    '
     loop                              '
     exit do                           '
    end if                             '
'--------------------------------------'
    if opp=63 then                     ' ? print
     if vsi(pai)=1 then print vcd(pai);'
     if vsi(pai)=2 then print vcz(pai);'
     if asc(vcz(cst),cwi+1)=63 then    ' ?? no line feed
      ipi+=1:exit do                   '
     end if                            '
     print                             ' otherwise line feed
     exit do                           '
    end if                             '
'--------------------------------------'
    if opp=60 then                     ' < as exit from method
     returns()
     exit do                           '
    end if                             '
'--------------------------------------'
    if opp=96 then                     ' ` mark iquotes
     if vsi(pai)=1 then                '
      print vcd(pai);                  '
     end if                            '
     if vsi(pai)=2 then                '
      print vcz(pai);                  '
     end if                            '
    end if                             '
'--------------------------------------'
'   drop thru..                        '
'--------------------------------------'
    if (opp=36)or(opp=96) then         ' $ iquote block
     v=instr(cwi+1,vcz(cst),chr$(36))  '
     if v=0 then v=len(vcz(cst))+1     '
     i=instr(cwi+1,vcz(cst),chr$(96))  ' iquote
     if (i=0)or(i>v) then i=v          '
     ipi=i+1                           '
     cwi+=1                            '
     if chn=0 then
      print mid$(vcz(cst),cwi,i-cwi);   '
     end if
     if chn>0 then
      print #chn,mid$(vcz(cst),cwi,i-cwi); '
     end if     
     exit do                           '
    end if                             '
'--------------------------------------'
    exit do                            ' end of (opi>10) cases
   loop                                '
  end if                               ' end of (opi>10)
'--------------------------------------'
  if pai<VBS then                        '
   function=22:exit function           ' stack underflow error
  end if                               '
  if pvi>pai then pvi=pai              ' limit named var scope
 loop                                  ' end of interpreter loop
'======================================'
 'print "ok"                           ' diagnostics / end of programme
 'print w,vsi(pai),vcd(pai),vcz(pai),vaz(pai) ' diagnostics
 function=0                            ' no errors. successful completion
end function                           '
'======================================'






'======================================'
' TEST DATA                            '
'======================================'
                                       '
 dim e as long                         ' error code
                                       '
'--------------------------------------'
                                       '
 e=interpret(" 'main.prg' load ")      '
                                       '
                                       '
'--------------------------------------'
' if e=0 then print "okay"             '
'--------------------------------------'
' ERROR REPORT                         '                                       '
'--------------------------------------'
 if e>0 then                           '
  v=1                                  '
  i=0                                  '
  do                                   '
   i=instr(i+1,vcz(cst),chr$(10))      '
   if i=0 then exit do                 '
   if i>ipi then exit do               '
   v+=1                                '
  loop                                 '
  print "error ";e;" line ";v          '
  print vaz(cst)          '            '
 end if                                '
'======================================'
